// Code generated by go-enum
// DO NOT EDIT!

package dkim

import (
	"fmt"
)

const (
	// StatusNone is a Status of type None
	StatusNone Status = iota
	// StatusFail is a Status of type Fail
	StatusFail
	// StatusPass is a Status of type Pass
	StatusPass
	// StatusUnknown is a Status of type Unknown
	StatusUnknown
)

const _StatusName = "nonefailpassunknown"

var _StatusMap = map[Status]string{
	0: _StatusName[0:4],
	1: _StatusName[4:8],
	2: _StatusName[8:12],
	3: _StatusName[12:19],
}

// String implements the Stringer interface.
func (x Status) String() string {
	if str, ok := _StatusMap[x]; ok {
		return str
	}
	return fmt.Sprintf("Status(%d)", x)
}

var _StatusValue = map[string]Status{
	_StatusName[0:4]:   0,
	_StatusName[4:8]:   1,
	_StatusName[8:12]:  2,
	_StatusName[12:19]: 3,
}

// ParseStatus attempts to convert a string to a Status
func ParseStatus(name string) (Status, error) {
	if x, ok := _StatusValue[name]; ok {
		return x, nil
	}
	return Status(0), fmt.Errorf("%s is not a valid Status", name)
}

// MarshalText implements the text marshaller method
func (x Status) MarshalText() ([]byte, error) {
	return []byte(x.String()), nil
}

// UnmarshalText implements the text unmarshaller method
func (x *Status) UnmarshalText(text []byte) error {
	name := string(text)
	tmp, err := ParseStatus(name)
	if err != nil {
		return err
	}
	*x = tmp
	return nil
}
